<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::entropy_decoder_kernel_2 Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1entropy__decoder__kernel__2.html">entropy_decoder_kernel_2</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1entropy__decoder__kernel__2-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::entropy_decoder_kernel_2 Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a050aab5de3b5cb4d6e1fb8dbb75e0ca9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__decoder__kernel__2.html#a050aab5de3b5cb4d6e1fb8dbb75e0ca9">entropy_decoder_kernel_2</a> ()</td></tr>
<tr class="separator:a050aab5de3b5cb4d6e1fb8dbb75e0ca9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8188d6ef83a0a9ab761f18dc4398924b"><td class="memItemLeft" align="right" valign="top"><a id="a8188d6ef83a0a9ab761f18dc4398924b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a8188d6ef83a0a9ab761f18dc4398924b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9fc3865cdab8e087b956e17263ecd23a"><td class="memItemLeft" align="right" valign="top"><a id="a9fc3865cdab8e087b956e17263ecd23a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_stream</b> (std::istream &amp;in)</td></tr>
<tr class="separator:a9fc3865cdab8e087b956e17263ecd23a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a097012db40f7d72228f43fb5f167366e"><td class="memItemLeft" align="right" valign="top"><a id="a097012db40f7d72228f43fb5f167366e"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>stream_is_set</b> () const</td></tr>
<tr class="separator:a097012db40f7d72228f43fb5f167366e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba5927e4d1c65a2b280009a94782f913"><td class="memItemLeft" align="right" valign="top"><a id="aba5927e4d1c65a2b280009a94782f913"></a>
std::istream &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>get_stream</b> () const</td></tr>
<tr class="separator:aba5927e4d1c65a2b280009a94782f913"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9fcc3ce9eba605630f929601ee3042f6"><td class="memItemLeft" align="right" valign="top"><a id="a9fcc3ce9eba605630f929601ee3042f6"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>decode</b> (uint32 low_count, uint32 high_count)</td></tr>
<tr class="separator:a9fcc3ce9eba605630f929601ee3042f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a17e1c5172f0ae2814e14b77272b92f76"><td class="memItemLeft" align="right" valign="top"><a id="a17e1c5172f0ae2814e14b77272b92f76"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>get_target_called</b> () const</td></tr>
<tr class="separator:a17e1c5172f0ae2814e14b77272b92f76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a461e4851f6813dc2fbbf1439523729ba"><td class="memItemLeft" align="right" valign="top"><a id="a461e4851f6813dc2fbbf1439523729ba"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>get_target</b> (uint32 total)</td></tr>
<tr class="separator:a461e4851f6813dc2fbbf1439523729ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a72013ab30dadf7dc5252649a883cf686"><td class="memItemLeft" align="right" valign="top"><a id="a72013ab30dadf7dc5252649a883cf686"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_decoder_kernel_2</b> (<a class="el" href="classdlib_1_1entropy__decoder__kernel__2.html">entropy_decoder_kernel_2</a> &amp;)</td></tr>
<tr class="separator:a72013ab30dadf7dc5252649a883cf686"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c58e29cd04857c44cac21a6f38306ed"><td class="memItemLeft" align="right" valign="top"><a id="a4c58e29cd04857c44cac21a6f38306ed"></a>
<a class="el" href="classdlib_1_1entropy__decoder__kernel__2.html">entropy_decoder_kernel_2</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1entropy__decoder__kernel__2.html">entropy_decoder_kernel_2</a> &amp;)</td></tr>
<tr class="separator:a4c58e29cd04857c44cac21a6f38306ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a0a66efd1f44e708ed1972d5f6c762098"><td class="memItemLeft" align="right" valign="top"><a id="a0a66efd1f44e708ed1972d5f6c762098"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_low</b></td></tr>
<tr class="separator:a0a66efd1f44e708ed1972d5f6c762098"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7fe68ffdad4f20b3e2998df81623d07"><td class="memItemLeft" align="right" valign="top"><a id="ac7fe68ffdad4f20b3e2998df81623d07"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_high</b></td></tr>
<tr class="separator:ac7fe68ffdad4f20b3e2998df81623d07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a293cd86980e12e203f0c53373a053e52"><td class="memItemLeft" align="right" valign="top"><a id="a293cd86980e12e203f0c53373a053e52"></a>
std::istream *&#160;</td><td class="memItemRight" valign="bottom"><b>in</b></td></tr>
<tr class="separator:a293cd86980e12e203f0c53373a053e52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5df71e38df37404ff3d793068bb9920"><td class="memItemLeft" align="right" valign="top"><a id="af5df71e38df37404ff3d793068bb9920"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>low</b></td></tr>
<tr class="separator:af5df71e38df37404ff3d793068bb9920"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fce1dd8702c4795f68454eddefb05af"><td class="memItemLeft" align="right" valign="top"><a id="a1fce1dd8702c4795f68454eddefb05af"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>high</b></td></tr>
<tr class="separator:a1fce1dd8702c4795f68454eddefb05af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a3b4f6ad0d8a25a7c3eb418d3305eeb"><td class="memItemLeft" align="right" valign="top"><a id="a1a3b4f6ad0d8a25a7c3eb418d3305eeb"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>target</b></td></tr>
<tr class="separator:a1a3b4f6ad0d8a25a7c3eb418d3305eeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b876a346c08d44bd0d7298adf3138a1"><td class="memItemLeft" align="right" valign="top"><a id="a2b876a346c08d44bd0d7298adf3138a1"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>r</b></td></tr>
<tr class="separator:a2b876a346c08d44bd0d7298adf3138a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ae57d7588124028bea7dd5e64002abb"><td class="memItemLeft" align="right" valign="top"><a id="a5ae57d7588124028bea7dd5e64002abb"></a>
std::streambuf *&#160;</td><td class="memItemRight" valign="bottom"><b>streambuf</b></td></tr>
<tr class="separator:a5ae57d7588124028bea7dd5e64002abb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a050aab5de3b5cb4d6e1fb8dbb75e0ca9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a050aab5de3b5cb4d6e1fb8dbb75e0ca9">&#9670;&nbsp;</a></span>entropy_decoder_kernel_2()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dlib::entropy_decoder_kernel_2::entropy_decoder_kernel_2 </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">GENERAL NOTES
    this decoder is implemented using "range" coding

INITIAL VALUE
    in       == 0
    initial_low      == 0x00000001  (slightly more than zero)
    initial_high     == 0xffffffff  (slightly less than one, 0.99999999976717)
    target   == 0x00000000  (zero)
    low      == initial_low
    high     == initial_high
    r        == 0

CONVENTION
    if (in != 0)
         in       == get_stream()
        true      == stream_is_set()
        streambuf == in-&gt;rdbuf()
    else
        false   == stream_is_set()


    low      == the low end of the range used for arithmetic encoding.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so it is
                always in the range [0,1)

                low is also never allowed to be zero to avoid overflow
                in the calculation (high-low+1)/total.

    high     == the high end of the range - 1 used for arithmetic encoding.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so when we
                interpret high as a real number then it is always in the
                range [0,1)

                the range for arithmetic encoding is always 
                [low,high + 0.9999999...)   the 0.9999999... is why
                high == real upper range - 1

    target  ==  32 bits of the fraction produced from an arithmetic encoder.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so it is
                always in the range [0,1)      

    r       ==  the value (high-low+1)/total from the last call to 
                get_target() or 0 if get_target_called() should be false

    get_target_called() == (r != 0)
</pre><p>! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="entropy__decoder__kernel__2_8h_source.html">entropy_decoder_kernel_2.h</a></li>
<li>entropy_decoder_kernel_2.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
